# Google Cloud Platform C++ Client Libraries

<!-- This file is automatically generated by ci/test-markdown/generate-readme.sh -->

[![GCB CI status][gcb-clang-tidy-shield]][gcb-clang-tidy-link]
[![Kokoro CI status][kokoro-windows-cmake-shield]][kokoro-windows-cmake-link]
[![Kokoro CI status][kokoro-macos-cmake-shield]][kokoro-macos-cmake-link]
[![Codecov Coverage status][codecov-shield]][codecov-link]<br>
[![GCB CI status][gcb-asan-shield]][gcb-asan-link]
[![Kokoro CI status][kokoro-windows-bazel-shield]][kokoro-windows-bazel-link]
[![Kokoro CI status][kokoro-macos-bazel-shield]][kokoro-macos-bazel-link]

[kokoro-windows-cmake-shield]: https://storage.googleapis.com/cloud-cpp-kokoro-status/kokoro-windows-cmake.svg
[kokoro-windows-cmake-link]: https://storage.googleapis.com/cloud-cpp-kokoro-status/kokoro-windows-cmake-link.html
[kokoro-windows-bazel-shield]: https://storage.googleapis.com/cloud-cpp-kokoro-status/kokoro-windows-bazel.svg
[kokoro-windows-bazel-link]: https://storage.googleapis.com/cloud-cpp-kokoro-status/kokoro-windows-bazel-link.html
[kokoro-macos-cmake-shield]: https://storage.googleapis.com/cloud-cpp-kokoro-status/macos/kokoro-cmake-vcpkg.svg
[kokoro-macos-cmake-link]: https://storage.googleapis.com/cloud-cpp-kokoro-status/macos/kokoro-cmake-vcpkg-link.html
[kokoro-macos-bazel-shield]: https://storage.googleapis.com/cloud-cpp-kokoro-status/macos/kokoro-bazel.svg
[kokoro-macos-bazel-link]: https://storage.googleapis.com/cloud-cpp-kokoro-status/macos/kokoro-bazel-link.html
[codecov-shield]: https://codecov.io/gh/googleapis/google-cloud-cpp/branch/main/graph/badge.svg
[codecov-link]: https://codecov.io/gh/googleapis/google-cloud-cpp
[gcb-clang-tidy-shield]: https://storage.googleapis.com/cloud-cpp-community-publiclogs/badges/google-cloud-cpp/main/clang-tidy.svg
[gcb-clang-tidy-link]: https://storage.googleapis.com/cloud-cpp-community-publiclogs/badges/google-cloud-cpp/main/clang-tidy.html
[gcb-asan-shield]: https://storage.googleapis.com/cloud-cpp-community-publiclogs/badges/google-cloud-cpp/main/asan.svg
[gcb-asan-link]: https://storage.googleapis.com/cloud-cpp-community-publiclogs/badges/google-cloud-cpp/main/asan.html

This repository contains idiomatic C++ client libraries for the following
[Google Cloud Platform](https://cloud.google.com/) services.

> Please check the [CHANGELOG] for important announcements and upcoming
> changes.<br>
> In particular, note that on (or about) **2022-06-01** this library will
> require C++ >= 14.

[CHANGELOG]: /CHANGELOG.md

<!-- inject-GA-libraries-start -->
* [Access Approval API](google/cloud/accessapproval/README.md)
  [[quickstart]](google/cloud/accessapproval/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-accessapproval/latest)
* [Access Context Manager API](google/cloud/accesscontextmanager/README.md)
  [[quickstart]](google/cloud/accesscontextmanager/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-accesscontextmanager/latest)
* [API Gateway API](google/cloud/apigateway/README.md)
  [[quickstart]](google/cloud/apigateway/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-apigateway/latest)
* [Apigee Connect API](google/cloud/apigeeconnect/README.md)
  [[quickstart]](google/cloud/apigeeconnect/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-apigeeconnect/latest)
* [App Engine Admin API](google/cloud/appengine/README.md)
  [[quickstart]](google/cloud/appengine/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-appengine/latest)
* [Artifact Registry API](google/cloud/artifactregistry/README.md)
  [[quickstart]](google/cloud/artifactregistry/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-artifactregistry/latest)
* [Cloud Asset API](google/cloud/asset/README.md)
  [[quickstart]](google/cloud/asset/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-asset/latest)
* [Assured Workloads API](google/cloud/assuredworkloads/README.md)
  [[quickstart]](google/cloud/assuredworkloads/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-assuredworkloads/latest)
* [Cloud AutoML API](google/cloud/automl/README.md)
  [[quickstart]](google/cloud/automl/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-automl/latest)
* [Google Cloud BigQuery](google/cloud/bigquery/README.md)
  [[quickstart]](google/cloud/bigquery/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-bigquery/latest)
* [Google Cloud Bigtable](google/cloud/bigtable/README.md)
  [[quickstart]](google/cloud/bigtable/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-bigtable/latest)
* [Cloud Billing Budget API](google/cloud/billing/README.md)
  [[quickstart]](google/cloud/billing/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-billing/latest)
* [Binary Authorization API](google/cloud/binaryauthorization/README.md)
  [[quickstart]](google/cloud/binaryauthorization/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-binaryauthorization/latest)
* [Cloud Channel API](google/cloud/channel/README.md)
  [[quickstart]](google/cloud/channel/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-channel/latest)
* [Cloud Build API](google/cloud/cloudbuild/README.md)
  [[quickstart]](google/cloud/cloudbuild/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-cloudbuild/latest)
* [Cloud Composer](google/cloud/composer/README.md)
  [[quickstart]](google/cloud/composer/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-composer/latest)
* [Contact Center AI Insights API](google/cloud/contactcenterinsights/README.md)
  [[quickstart]](google/cloud/contactcenterinsights/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-contactcenterinsights/latest)
* [Kubernetes Engine API](google/cloud/container/README.md)
  [[quickstart]](google/cloud/container/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-container/latest)
* [Container Analysis API](google/cloud/containeranalysis/README.md)
  [[quickstart]](google/cloud/containeranalysis/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-containeranalysis/latest)
* [Google Cloud Data Catalog API](google/cloud/datacatalog/README.md)
  [[quickstart]](google/cloud/datacatalog/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-datacatalog/latest)
* [Database Migration API](google/cloud/datamigration/README.md)
  [[quickstart]](google/cloud/datamigration/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-datamigration/latest)
* [Cloud Dataplex API](google/cloud/dataplex/README.md)
  [[quickstart]](google/cloud/dataplex/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-dataplex/latest)
* [Cloud Dataproc API](google/cloud/dataproc/README.md)
  [[quickstart]](google/cloud/dataproc/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-dataproc/latest)
* [Stackdriver Debugger API](google/cloud/debugger/README.md)
  [[quickstart]](google/cloud/debugger/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-debugger/latest)
* [Dialogflow CX API](google/cloud/dialogflow_cx/README.md)
  [[quickstart]](google/cloud/dialogflow_cx/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-dialogflow_cx/latest)
* [Dialogflow ES API](google/cloud/dialogflow_es/README.md)
  [[quickstart]](google/cloud/dialogflow_es/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-dialogflow_es/latest)
* [Cloud Data Loss Prevention (DLP) API](google/cloud/dlp/README.md)
  [[quickstart]](google/cloud/dlp/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-dlp/latest)
* [Cloud Document AI API](google/cloud/documentai/README.md)
  [[quickstart]](google/cloud/documentai/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-documentai/latest)
* [Eventarc API](google/cloud/eventarc/README.md)
  [[quickstart]](google/cloud/eventarc/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-eventarc/latest)
* [Cloud Filestore API](google/cloud/filestore/README.md)
  [[quickstart]](google/cloud/filestore/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-filestore/latest)
* [Cloud Functions API](google/cloud/functions/README.md)
  [[quickstart]](google/cloud/functions/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-functions/latest)
* [Game Services API](google/cloud/gameservices/README.md)
  [[quickstart]](google/cloud/gameservices/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-gameservices/latest)
* [GKE Hub](google/cloud/gkehub/README.md)
  [[quickstart]](google/cloud/gkehub/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-gkehub/latest)
* [Google Cloud IAM](google/cloud/iam/README.md)
  [[quickstart]](google/cloud/iam/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-iam/latest)
* [Cloud Identity-Aware Proxy API](google/cloud/iap/README.md)
  [[quickstart]](google/cloud/iap/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-iap/latest)
* [Cloud IDS API](google/cloud/ids/README.md)
  [[quickstart]](google/cloud/ids/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-ids/latest)
* [Cloud IoT API](google/cloud/iot/README.md)
  [[quickstart]](google/cloud/iot/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-iot/latest)
* [Cloud Key Management Service (KMS) API](google/cloud/kms/README.md)
  [[quickstart]](google/cloud/kms/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-kms/latest)
* [Cloud Natural Language API](google/cloud/language/README.md)
  [[quickstart]](google/cloud/language/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-language/latest)
* [Google Cloud Logging](google/cloud/logging/README.md)
  [[quickstart]](google/cloud/logging/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-logging/latest)
* [Managed Service for Microsoft Active Directory API](google/cloud/managedidentities/README.md)
  [[quickstart]](google/cloud/managedidentities/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-managedidentities/latest)
* [Cloud Memorystore for Memcached API](google/cloud/memcache/README.md)
  [[quickstart]](google/cloud/memcache/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-memcache/latest)
* [Cloud Monitoring API](google/cloud/monitoring/README.md)
  [[quickstart]](google/cloud/monitoring/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-monitoring/latest)
* [Network Management API](google/cloud/networkmanagement/README.md)
  [[quickstart]](google/cloud/networkmanagement/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-networkmanagement/latest)
* [Notebooks API](google/cloud/notebooks/README.md)
  [[quickstart]](google/cloud/notebooks/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-notebooks/latest)
* [Organization Policy API](google/cloud/orgpolicy/README.md)
  [[quickstart]](google/cloud/orgpolicy/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-orgpolicy/latest)
* [OS Config API](google/cloud/osconfig/README.md)
  [[quickstart]](google/cloud/osconfig/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-osconfig/latest)
* [Cloud OS Login API](google/cloud/oslogin/README.md)
  [[quickstart]](google/cloud/oslogin/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-oslogin/latest)
* [Policy Troubleshooter API](google/cloud/policytroubleshooter/README.md)
  [[quickstart]](google/cloud/policytroubleshooter/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-policytroubleshooter/latest)
* [Certificate Authority API](google/cloud/privateca/README.md)
  [[quickstart]](google/cloud/privateca/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-privateca/latest)
* [Cloud Profiler API](google/cloud/profiler/README.md)
  [[quickstart]](google/cloud/profiler/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-profiler/latest)
* [Google Cloud Pub/Sub](google/cloud/pubsub/README.md)
  [[quickstart]](google/cloud/pubsub/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-pubsub/latest)
* [Recommender](google/cloud/recommender/README.md)
  [[quickstart]](google/cloud/recommender/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-recommender/latest)
* [Google Cloud Memorystore for Redis API](google/cloud/redis/README.md)
  [[quickstart]](google/cloud/redis/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-redis/latest)
* [Cloud Resource Manager API](google/cloud/resourcemanager/README.md)
  [[quickstart]](google/cloud/resourcemanager/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-resourcemanager/latest)
* [Resource Settings API](google/cloud/resourcesettings/README.md)
  [[quickstart]](google/cloud/resourcesettings/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-resourcesettings/latest)
* [Retail API](google/cloud/retail/README.md)
  [[quickstart]](google/cloud/retail/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-retail/latest)
* [Cloud Scheduler API](google/cloud/scheduler/README.md)
  [[quickstart]](google/cloud/scheduler/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-scheduler/latest)
* [Secret Manager API](google/cloud/secretmanager/README.md)
  [[quickstart]](google/cloud/secretmanager/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-secretmanager/latest)
* [Security Command Center API](google/cloud/securitycenter/README.md)
  [[quickstart]](google/cloud/securitycenter/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-securitycenter/latest)
* [Service Control API](google/cloud/servicecontrol/README.md)
  [[quickstart]](google/cloud/servicecontrol/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-servicecontrol/latest)
* [Service Directory API](google/cloud/servicedirectory/README.md)
  [[quickstart]](google/cloud/servicedirectory/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-servicedirectory/latest)
* [Service Management API](google/cloud/servicemanagement/README.md)
  [[quickstart]](google/cloud/servicemanagement/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-servicemanagement/latest)
* [Service Usage API](google/cloud/serviceusage/README.md)
  [[quickstart]](google/cloud/serviceusage/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-serviceusage/latest)
* [Cloud Shell API](google/cloud/shell/README.md)
  [[quickstart]](google/cloud/shell/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-shell/latest)
* [Google Cloud Spanner](google/cloud/spanner/README.md)
  [[quickstart]](google/cloud/spanner/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-spanner/latest)
* [Cloud Speech-to-Text API](google/cloud/speech/README.md)
  [[quickstart]](google/cloud/speech/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-speech/latest)
* [Google Cloud Storage](google/cloud/storage/README.md)
  [[quickstart]](google/cloud/storage/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-storage/latest)
* [Storage Transfer API](google/cloud/storagetransfer/README.md)
  [[quickstart]](google/cloud/storagetransfer/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-storagetransfer/latest)
* [Cloud Talent Solution API](google/cloud/talent/README.md)
  [[quickstart]](google/cloud/talent/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-talent/latest)
* [Cloud Tasks API](google/cloud/tasks/README.md)
  [[quickstart]](google/cloud/tasks/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-tasks/latest)
* [Cloud Text-to-Speech API](google/cloud/texttospeech/README.md)
  [[quickstart]](google/cloud/texttospeech/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-texttospeech/latest)
* [Cloud TPU API](google/cloud/tpu/README.md)
  [[quickstart]](google/cloud/tpu/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-tpu/latest)
* [Stackdriver Trace API](google/cloud/trace/README.md)
  [[quickstart]](google/cloud/trace/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-trace/latest)
* [Cloud Translation API](google/cloud/translate/README.md)
  [[quickstart]](google/cloud/translate/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-translate/latest)
* [Cloud Video Intelligence API](google/cloud/videointelligence/README.md)
  [[quickstart]](google/cloud/videointelligence/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-videointelligence/latest)
* [Cloud Vision API](google/cloud/vision/README.md)
  [[quickstart]](google/cloud/vision/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-vision/latest)
* [VM Migration API](google/cloud/vmmigration/README.md)
  [[quickstart]](google/cloud/vmmigration/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-vmmigration/latest)
* [Serverless VPC Access API](google/cloud/vpcaccess/README.md)
  [[quickstart]](google/cloud/vpcaccess/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-vpcaccess/latest)
* [Web Risk API](google/cloud/webrisk/README.md)
  [[quickstart]](google/cloud/webrisk/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-webrisk/latest)
* [Web Security Scanner API](google/cloud/websecurityscanner/README.md)
  [[quickstart]](google/cloud/websecurityscanner/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-websecurityscanner/latest)
* [Workflow Executions API](google/cloud/workflows/README.md)
  [[quickstart]](google/cloud/workflows/quickstart/README.md)
  [[reference]](https://googleapis.dev/cpp/google-cloud-workflows/latest)
<!-- inject-GA-libraries-end -->

See each library's `README.md` file for more information about:

* Where to find the documentation for the library and the service.
* How to get started using the library.
* How to incorporate the library into your build system.
* The library's support status if not Generally Available (GA); unless noted in
  a library's `README.md`, these libraries are all GA and supported by Google.

## Building and Installing

This is a quickstart guide for developers wanting to compile the libraries and
run the examples included with the libraries.

* Packaging maintainers or developers who prefer to install the library in a
  fixed directory (such as `/usr/local` or `/opt`) should consult the
  [packaging guide](/doc/packaging.md).
* Developers wanting to use the libraries as part of a larger CMake or Bazel
  project should consult the [quickstart guides](#quickstart) for the library
  or libraries they want to use.
* Developers wanting to compile the library just to run some of the examples or
  tests should read the current document.
* Contributors and developers to `google-cloud-cpp` should consult the guide to
  [setup a development workstation][howto-setup-dev-workstation].

[howto-setup-dev-workstation]: /doc/contributor/howto-guide-setup-development-workstation.md

### Building with Bazel

This library requires Bazel >= 4.0. From the top-level directory, run the usual
commands.

```shell
bazel build //...
```

### Building with CMake

This library requires CMake >= 3.5. If you are planning to install the libraries
please consult the [packaging guide](/doc/packaging.md), these instructions will
**NOT** produce artifacts that you can put in `/usr/local`, or share with your
colleagues.

From the top-level directory of `google-cloud-cpp` run these commands:

```shell
git -C $HOME clone https://github.com/microsoft/vcpkg.git
env VCPKG_ROOT=$HOME/vcpkg $HOME/vcpkg/bootstrap-vcpkg.sh
cmake -H. -Bcmake-out/ -DCMAKE_TOOLCHAIN_FILE=$HOME/vcpkg/scripts/buildsystems/vcpkg.cmake
cmake --build cmake-out -- -j $(nproc)
```

The binary artifacts, such as examples, will be placed in `cmake-out/`.

## Quickstart

Each library (linked above) contains a directory named `quickstart/` that's
intended to help you get up and running in a matter of minutes. This
`quickstart/` directory contains a minimal "Hello World" program demonstrating
how to use the library, along with minimal build files for common build
systems, such as CMake and Bazel.

As an example, the following code snippet, taken from [Google Cloud
Storage](google/cloud/storage/README.md), should give you a taste of what it's
like to use one of these C++ libraries.

<!-- inject-quickstart-start -->
```cc
#include "google/cloud/storage/client.h"
#include <iostream>

int main(int argc, char* argv[]) {
  if (argc != 2) {
    std::cerr << "Missing bucket name.\n";
    std::cerr << "Usage: quickstart <bucket-name>\n";
    return 1;
  }
  std::string const bucket_name = argv[1];

  // Create aliases to make the code easier to read.
  namespace gcs = ::google::cloud::storage;

  // Create a client to communicate with Google Cloud Storage. This client
  // uses the default configuration for authentication and project id.
  auto client = gcs::Client();

  auto writer = client.WriteObject(bucket_name, "quickstart.txt");
  writer << "Hello World!";
  writer.Close();
  if (writer.metadata()) {
    std::cout << "Successfully created object: " << *writer.metadata() << "\n";
  } else {
    std::cerr << "Error creating object: " << writer.metadata().status()
              << "\n";
    return 1;
  }

  auto reader = client.ReadObject(bucket_name, "quickstart.txt");
  if (!reader) {
    std::cerr << "Error reading object: " << reader.status() << "\n";
    return 1;
  }

  std::string contents{std::istreambuf_iterator<char>{reader}, {}};
  std::cout << contents << "\n";

  return 0;
}
```
<!-- inject-quickstart-end -->

## Support

* This project supports Windows, macOS, Linux
* This project supports C++11 (and higher) compilers (we test with GCC >= 6.3,
  Clang >= 6.0, and MSVC >= 2017)
* This project supports Bazel (>= 4.0) and CMake (>= 3.5) builds. See the
  [Quickstart examples](https://github.com/googleapis/google-cloud-cpp#quickstart)
* This project uses dependencies described in [doc/packaging.md](https://github.com/googleapis/google-cloud-cpp/blob/main/doc/packaging.md)
* This project works with or without exceptions enabled
* This project cuts [monthly releases](https://github.com/googleapis/google-cloud-cpp/releases) with detailed release notes

## Public API and API Breaking Changes

In general, we avoid making backwards incompatible changes to our C++ APIs (see
below for the definition of "API"). Sometimes such changes yield benefits to
our customers, in the form of better performance, easier-to-understand APIs,
and/or more consistent APIs across services. When these benefits warrant it, we
will announce these changes prominently in our `CHANGELOG.md` file and in the
affected release's notes. Nevertheless, though we take commercially reasonable
efforts to prevent this, it is possible that backwards incompatible changes go
undetected and, therefore, undocumented. We apologize if this is the case and
welcome feedback or bug reports to rectify the problem.

By "API" we mean the C++ API exposed by public header files in this repo. We
are not talking about the gRPC or REST APIs exposed by Google Cloud servers. We
are also talking only about A**P**I stability -- the ABI is subject to change
without notice. You should not assume that binary artifacts (e.g. static
libraries, shared objects, dynamically loaded libraries, object files) created
with one version of the library are usable with newer/older versions of the
library. The ABI may, and does, change on "minor revisions", and even patch
releases.

We request that our customers adhere to the following guidelines to avoid
accidentally depending on parts of the library we do not consider to be part of
the public API and therefore may change (including removal) without notice:

Previous versions of the library will remain available on the [GitHub Releases
page](https://github.com/googleapis/google-cloud-cpp/releases). In many cases,
you will be able to use an older version even if a newer version has changes
that you are unable (or do not have time) to adopt.

Note that this document has no bearing on the Google Cloud Platform deprecation
policy described at https://cloud.google.com/terms.

### C++ Symbols and Files

* You should only include headers matching the `google/cloud/${library}/*.h`,
  `google/cloud/${library}/mock/*.h` or `google/cloud/*.h` patterns.
* You should **NOT** directly include headers in any subdirectories, such as
  `google/cloud/${library}/internal`.
* The files *included from* our public headers are **not part of our public
  API**. Depending on indirect includes may break your build in the future, as
  we may change a header `"foo.h"` to stop including `"bar.h"` if `"foo.h"` no
  longer needs the symbols in `"bar.h"`. To avoid having your code broken, you
  should directly include the public headers that define all the symbols you
  use (this is sometimes known as
  [include-what-you-use](https://include-what-you-use.org/)).
* Any file or symbol that lives within a directory or namespace containing
  `internal`, `impl`, `test`, `detail`, `benchmark`, `sample`, or `example`, is
  explicitly **not part of our public API**.
* Any file or symbol with `Impl` or `impl` in its name is **not part of our
  public API**.
* Any symbol with `experimental` in its name is not part of the public API.
* You should avoid naming our inline namespaces (even avoid spelling the
  preprocessor names like `GOOGLE_CLOUD_CPP_NS`) and instead rely on them being
  a transparent versioning mechanism that you almost certainly don't care
  about. If you do spell out specific inline namespace names, your code will be
  tightly coupled with that specific version and will likely break when
  upgrading to a new version of our library.

## Beyond the C++ API

Applications developers interact with a C++ library through more than just
the C++ symbols and headers. They also need to reference the name of the
library in their build scripts. Depending on the build system they use
this may be a CMake target, a Bazel rule, a pkg-config module, or just the
name of some object in the file system.

As with the C++ API, we try to avoid breaking changes to these interface
points. Sometimes such changes yield benefits to our customers, in the form of
bug fixes, increased consistency across services, or easier to understand names.
When these benefits warrant it, we will announce these changes prominently in
our `CHANGELOG.md` file and in the affected release's notes.  Nevertheless,
though we take commercially reasonable efforts to prevent this, it is possible
that backwards incompatible changes go undetected and, therefore, undocumented.
We apologize if this is the case and welcome feedback or bug reports to rectify
the problem.

### Experimental Libraries

From time to time we add libraries to `google-cloud-cpp` to validate new
designs, expose experimental (or otherwise not generally available) GCP
features, or simply because a library is not yet complete. Such libraries
will have `experimental` in their CMake target and Bazel rule names. The
README file for these libraries will also document that they are experimental.
Such libraries are subject to change, including removal, without notice.
This includes, but it is not limited to, all their symbols, pre-processor
macros, files, targets, rules, and installed artifacts.

### Bazel rules

Only the rules exported at the top-level directory are intended for customer
use, e.g.,`//:spanner`. Experimental rules have `experimental` in their name,
e.g. `//:experimental-logging`. As previously stated, experimental rules are
subject to change or removal without notice.

### CMake targets and packages

Only CMake packages starting with the `google_cloud_cpp_` prefix are intended
for customer use. Only targets starting with `google-cloud-cpp::`, are intended
for customer use. Experimental targets have `experimental` in their name (e.g.
`google-cloud-cpp::experimental-logging`). As previously stated, experimental
targets are subject to change or removal without notice.

### pkg-config modules

Only modules starting with `google_cloud_cpp_` are intended for customer use.

### Unsupported use cases

We try to provide stable names for the previously described mechanisms:

* Bazel rules,
* CMake targets loaded via `find_package()`,
* pkg-config modules

It is certainly possible to use the library using other approaches. While
these may work, we may accidentally break these from time to time. Examples of
such, and the recommended alternatives, include:

* CMake's `FetchContent` and/or git submodules: in these approaches the
  `google-cloud-cpp` library becomes a subdirectory of a larger CMake build
  We do not test `google-cloud-cpp` in these  configurations, and we find them
  brittle as **all** CMake targets become visible to the larger project.
  This is both prone to conflicts, and makes it impossible to enforce that
  some targets are only for testing or are implementation details.
  Applications may want to consider source package managers, such as
  `vcpkg`, or CMake super builds via `ExternalProject_Add()` as alternatives.

* Using library names directly: applications should not use the
  library names, e.g., by using `-lgoogle_cloud_cpp_bigtable`
  in build scripts. We may need to split or merge libraries over time,
  making such names unstable. Applications should use CMake targets,
  e.g., `google-cloud-cpp::bigtable`, or pkg-config modules, e.g.,
  `$(pkg-config google_cloud_cpp_bigtable --libs)` instead.

### Documentation and Comments

The documentation (and its links) is intended for human consumption and not
third party websites, or automation (such as scripts scrapping the contents).
The contents and links of our documentation may change without notice.

### Other Interface Points

We think this covers all interface points, if we missed something please
file a [GitHub issue][github-issue].

## Contact us

* [GitHub Discussions] -- For questions and general comments
* [GitHub Issues] -- For reporting bugs and feature requests

[GitHub Discussions]: https://github.com/googleapis/google-cloud-cpp/discussions
[GitHub Issues]: https://github.com/googleapis/google-cloud-cpp/issues

## Contributing changes

See [`CONTRIBUTING.md`](/CONTRIBUTING.md) for details on how to contribute to
this project, including how to build and test your changes as well as how to
properly format your code.

## Licensing

Apache 2.0; see [`LICENSE`](/LICENSE) for details.
